C/* 
C * This version looks for regular increment patterns in the ja array.
C * The ka array basically gives the diagonal blocks of the matrix.
C * The data structure is otherwise AIJ; in particular, data has NOT
C * been re-ordered to improve diagonal access.
C */
      subroutine mv( ia, ja, ka, a, x, y, n )
      implicit none
      integer i, jrow, j, ncol, n
      integer k, cnt, kk, col, acol, bsize
      integer ia(*), ja(*), ka(*)
      double precision sum, col2, s1, s2
      double precision a(*), x(n), y(n)
C
      i = 1
      cnt = 0
 10   continue
         if (i.gt.n) go to 20
         jrow  = ia(i)
         ncol  = ia(i+1) - jrow
         cnt = cnt+1
         k	  = ka(cnt)
         bsize = k - i + 1
C      print*,i,'jrow',jrow,' ncol',ncol,'bsize',bsize,'cnt',cnt,k
         if (bsize .eq. 1) then
C           /* If a single row, drop to regular code */
	   sum  = 0.0
           do j = 1,ncol
	       sum = sum + a(jrow)*x(ja(jrow))
               jrow = jrow + 1
C           print*,jrow,'ajrow',a(jrow),'jajrow',ja(jrow),'x',x(ja(jrow))
           enddo
	   y(i) = sum
c          print*,i,'yi',y(i),'in block'
 	   i = i + 1
        else 
C            /* Switch to diagonal code */
           do kk = 0, bsize-1
	       y(i+kk) = 0.0
           enddo
           do j = 0,ncol-2,2
	       acol = jrow+j
	       col  = ja(acol)
	       col2 = ja(acol+1)
               do kk = 0,bsize-1,2
                 s1 = y(i+kk)
                 s2 = y(i+kk+1)
                 s1 = s1 + a(acol)*x(col+kk) + a(acol+1)*x(col2+kk)
		 acol    = acol +  ncol
                 s2 = s2 + a(acol)*x(col+kk+1) + a(acol+1)*x(col2+kk+1)
		 acol    = acol +  ncol
	         y(i+kk) = s1
	         y(i+kk+1) = s2
c         print*,'i',i,'j',j,'kk',kk,'s1',s1,'s2', s2
c          if (j.eq.ncol-1) print*,i+kk,'yi',y(i+kk),'in diag '
c          if (j.eq.ncol-1) print*,i+kk+1,'yi',y(i+kk+1),'in diag '
               enddo
               if  (kk.lt.bsize) then
                 y(i+kk) = y(i+kk) + a(acol)*x(col+kk)
               endif
	   enddo
C         print*,i,'y',y(i+1),y(i+2),y(3+i)
           if (j .lt. ncol) then
            acol = jrow+j
            col  = ja(acol)
            do kk=0,bsize-2,2 
                s1 = y(i+kk) 
                s2 = y(i+kk+1)
                s1 = s1 + a(acol) * x(col+kk)
                acol  = acol + ncol
                s2 = s2 + a(acol) * x(col+kk+1)
                acol  = acol + ncol
                y(i+kk) = s1
                y(i+kk+1) = s2
c          print*,i+kk,'yi',y(i+kk),'in diag lt'
c          print*,i+kk+1,'yi',y(i+kk+1),'in diag lt'
            enddo
            if (kk .lt. bsize) then
                y(i+kk) = y(i+kk) + a(acol) * x(col+kk)
c          print*,i+kk,'yi',y(i+kk),'in diag x'
            endif
           endif
	   i = k+1
        endif
      go to 10
 20   continue
C
      return
      end
C
      integer function mvextra( ia, ja, a, n )
      implicit none
      integer n, ia(*), ja(*)
      double precision a(*)
      mvextra = n
      return
      end
C
      subroutine mvname( str )
      implicit none
      character*(*) str
      str = 'Fortran AIJ (unrolled) with Diagonal Block Detection'
      return
      end
C
      subroutine mvsetup( ia, ja, ka, a, n )
      implicit none
      integer ia(*), ja(*), ka(*)
      double precision a(*)
      integer i, n, pattern_row, offset, jpattern, npattern, cnt
      integer jrow, ncol, j
C 
      cnt = 1
C      /* Fill ka array with next row that has a different ja structure */
      pattern_row = 1
      offset      = 1
      jpattern = ia(pattern_row)
      npattern = ia(pattern_row+1) - jpattern
C       print*,'ia',ia(1),ia(2),ia(3),ia(4)
      do i = 2,n
  	jrow = ia(i) 
  	ncol = ia(i+1) - jrow
c       print*,ncol,npattern
  	if (ncol .ne. npattern) then
c          print*,'ncol ne npat',i,ncol,npattern,jrow,jpattern
C  #ifdef DEBUG
C  	  print*,"failed number in col", ncol
C  #endif
          ka(cnt)   = i-1
          cnt = cnt+1
c        print*,'second (ne)',cnt
c          print*,'ncol ne npat',cnt,ka(cnt-1)
          pattern_row = i
          offset	    = 0
          jpattern    = ia(pattern_row)
          npattern    = ia(pattern_row+1) - jpattern
  	else 
c          print*,'ncol eq npat',i,ncol,npattern,jrow,jpattern
C  	    /* Check each entry in ja */
  	    do j=0,ncol-1
  		if (ja(jrow+j) .ne. ja(jpattern+j) + offset + 1) then
C  #ifdef DEBUG
C  		    print*, "failed column", 
C     &		    ja(jrow+j), "not", ja(jpattern+j) + offset + 1
C  #endif
                go to 40
                endif
  	    enddo
 40     continue
  	    if (j  .ne. ncol) then
  		ka(cnt)	= i-1
                cnt = cnt + 1
c        print*,'third (eq)',cnt,j,ncol
c          print*,'ncol eq npat',cnt,ka(cnt-1)
  		pattern_row	= i
  		offset		= 0
  		jpattern	= ia(pattern_row)
  		npattern	= ia(pattern_row+1) - jpattern
  	    else 
  		offset = offset + 1
  	    endif
  	endif
      enddo
      ka(cnt) = n 
      cnt = cnt+1
C        print*,'last ',cnt
c          print*,'ncol out',cnt,ka(cnt)
C  #ifdef DEBUG
C      for (i=0 i<cnt i++) 
C  	printf( "ka[%d] = \t%d\n", i, ka[i] )
C  #endif
c      print*,'setup ka',(ka(i),i=1,5)
c      print*,'setup ja',(ja(i),i=1,5)
      return
      end
C
      subroutine mvflags( str )
      character*(*) str
      str = 'FLAGS'
      return
      end
